MultiOverlayV3.runJumpFlySpeedApp = {};

function MultiOverlayV3.runJumpFlySpeedApp:loadApp(self, isServer) --loadApp() <--needs for MultiOverlayV3
	if isServer then return;end;
	local version = 0.1; --before edit,check is MultiOverlayV3 Hud Mod App Version UpToDate or not (Check TestApp at MultiOverlayV3 Zip)
	print("---loading RunJumpFlySpeed App (".. tostring(version).. ") for ".. tostring(MultiOverlayV3.metadata.title))		
	--MultiOverlayV3.runJumpFlySpeedApp.mapIsLoad = false; --optional own function or ...
	if version >= MultiOverlayV3.metadata.clientAppVersion then
				
		local myCmdTable, errorTable = 0, {};
		
		--default values--
		local newCmdTable = {	
		realName = "RunJumpFlySpeed App";
		guiMenue = false;
		--guiMenueTable = 0;
		--guiMenueName = "";
		onOff = true;
		luaName = "runJumpFlySpeedApp"; --needs(string *your lua name*), for cmd action(is cmd action string) and classification in Save/XML --> ! should be unique !	
		cmdTable = {};	
		};
		--default values--
		
		--cmd 1--
		newCmdTable.cmdTable[1] = {
			cmdName = "playerSpeedHighNormalSlow";
			displayName = "Player Speed +/Normal/-";
			iconSuggestion = "runJumpFlySpeedAppIcon2_";
			iconSuggestionTxt = "Color/Rotate Icon";
			multiple = true;
			sortBy = "RunJumpFlySpeed App";
			infoTxt = "Erhöht/Reduziert deine Laufgeschwindigkeit\nSelect Clicks (Left +, Middle N, Right -)\nTip set runJumpFlySpeedAppIcon2_ (Color/Rotate)";
			helpTxt = "You run faster/slower";
			click = {mouseButtonLeft=true, mouseButtonMiddle=true, mouseButtonRight=true, key=false}; --left/middle/right MouseClick
			typ = "action";
			action = MultiOverlayV3.runJumpFlySpeedApp.playerSpeedHighNormalSlow;
			ownValues = {defaultWalkingSpeed=0, defaultRunningSpeed=0, defaultFallingSpeed=0, defaultCrouchingSpeed=0, defaultSwimmingSpeed=0, defaultCheatRunningSpeed=0, maxLevel=60, isLevel=0, minLevel=-5, 
				rotation={
					maxEnd 		= 0.7853981633974;
					level  		= 0.15707963267948; --5      --0.07853981633974 isLevel 10;
					maxIsLevel 	= 15;
					slow 		= -0.07853981633974;
					slowEnd		= -0.7853981633974;
					high 		= 0.07853981633974;
					highEnd 	= 0.7853981633974;
				};
			}; 
		};
		--cmd 1--
		--cmd 2--
		newCmdTable.cmdTable[2] = {
			cmdName = "playerFlightModus";
			displayName = "Player Flight On/Off";
			iconSuggestion = "runJumpFlySpeedIcon3_";
			iconSuggestionTxt = "Color Icon";
			multiple = true;
			sortBy = "RunJumpFlySpeed App";
			infoTxt = "Schaltet den Flight Modus an oder aus\nTip set runJumpFlySpeedAppIcon3_ (Color)";
			helpTxt = "Debug Flight Modus On/Off";
			click = {mouseButtonLeft=true, mouseButtonMiddle=true, mouseButtonRight=true, key=true};
			typ = "action";
			action = MultiOverlayV3.runJumpFlySpeedApp.playerFlightModus;
			ownValues = {debugFlightMode=false}; 
		};
		--cmd 2--
		--cmd 3--
		newCmdTable.cmdTable[3] = {
			cmdName = "playerFlightSpeedModus";
			displayName = "Player SpeedFlight On/Off";
			iconSuggestion = "runJumpFlySpeedAppIcon3_";
			iconSuggestionTxt = "Color Icon";
			multiple = true;
			sortBy = "RunJumpFlySpeed App";
			infoTxt = "Schaltet den Flight Modus an oder aus und setzt den Speed hoch\nTip set runJumpFlySpeedAppIcon3_ (Color)";
			helpTxt = "Debug Flight Modus On/Off and Running Speed Max";
			click = {mouseButtonLeft=true, mouseButtonMiddle=true, mouseButtonRight=true, key=true};
			typ = "action";
			action = MultiOverlayV3.runJumpFlySpeedApp.playerFlightSpeedModus;
			ownValues = {}; 
		};
		--cmd 3--
		--cmd 4--
		newCmdTable.cmdTable[4] = {
			cmdName = "playerJumpHighNormalLow";
			displayName = "Player Jump +/Normal/-";
			iconSuggestion = "runJumpFlySpeedAppIcon4_";
			iconSuggestionTxt = "Color Icon";
			multiple = true;
			sortBy = "RunJumpFlySpeed App";
			infoTxt = "Erhöht/Reduziert deine Sprung höhe\nSelect Clicks (Left +, Middle N, Right -)\nTip set runJumpFlySpeedAppIcon4_ (Color)";
			helpTxt = "You Jump higher/lower";
			click = {mouseButtonLeft=true, mouseButtonMiddle=true, mouseButtonRight=true, key=false};
			typ = "action";
			action = MultiOverlayV3.runJumpFlySpeedApp.playerJumpHighNormalLow; --a function
			ownValues = {defaultJump=0, isJump=1}; 
		};
		--cmd 4--	
		myCmdTable, errorTable = moSetGetCmd:generateNewCmd(newCmdTable);		
		if myCmdTable > 0 then MultiOverlayV3.runJumpFlySpeedApp.ownCmdTable = myCmdTable;end;
		local errorPrint = false;
		if errorPrint and #errorTable > 0 then
			for a=1, #errorTable do
				print("! ERROR ! RunJumpFlySpeed App -->cmd generate error ".. tostring(a).. ": ".. tostring(errorTable[a]))
			end;
		end;
		local overlayDir = "app/runJumpFlySpeedApp/"
		local  beginIcon, endIcon = moSetGetOverlays:loadPreviewAppIconsOverlays(self, overlayDir.. "runJumpFlySpeedApp.dds", "m256x256", "runJumpFlySpeedAppIcon", 2, 1, 4, "RunJumpFlySpeed App Icon", true); --App Icons for Moh PDAs
		local firstPos = beginIcon
		for a=beginIcon, endIcon do			
			if firstPos == a then 
				--moSetGetOverlays.previewAppIcons[a].typTable.groundColor = moColors.intern["white"];	
				moSetGetOverlays.previewAppIcons[a].iconTyp = 3;
				moSetGetOverlays.previewAppIcons[a].typTable.typ3 = {};
				moSetGetOverlays.previewAppIcons[a].typTable.typ3.color = {moColors.intern["darkGreen"], moColors.intern["warningRed"], false}; --On Off Status				
			else
				moSetGetOverlays.previewAppIcons[a].typTable.groundColor = moColors.intern["darkGray"];	
			end;	
		end;
	end;
end;

function MultiOverlayV3.runJumpFlySpeedApp.playerSpeedHighNormalSlow(...)
	if ... ~= nil then		
		local args = {...};		
		if args ~= nil and args[1] ~= nil and args[2] ~= nil and args[3] ~= nil and args[4] ~= nil then
			--if not g_currentMission.isMasterUser then 
			--	g_currentMission.hud:showInGameMessage("RunJumpFlySpeed App Info", "Speed Modus is Only for Admin Users", 0);
			--	return;
			--end;
			local ownCmdValue = MultiOverlayV3.cmdTable[args[2]].cmd[args[3]].ownValues;			
			if ownCmdValue == nil or type(ownCmdValue) ~= "table" then return;end;
			if args[6] ~= nil then ownCmdValue.isLevel = args[6];end; --set manual over playerFlightSpeedModus
			local iconName = Utils.getNoNil(args[4].appIconName, "")		
			local colorRotationIcon = iconName ~= nil and string.len(iconName) > 0 and iconName == "runJumpFlySpeedAppIcon2_" and moSetGetOverlays.appIcon[args[4].whereClick][iconName] ~= nil; --check ist richtige icon für cmd und multi color rotation
			if ownCmdValue.defaultWalkingSpeed == 0 then --saved first default values
				ownCmdValue.defaultWalkingSpeed		 = g_currentMission.player.motionInformation.maxWalkingSpeed;
				ownCmdValue.defaultRunningSpeed		 = g_currentMission.player.motionInformation.maxRunningSpeed;
				ownCmdValue.defaultSwimmingSpeed	 = g_currentMission.player.motionInformation.maxSwimmingSpeed;
				ownCmdValue.defaultCrouchingSpeed	 = g_currentMission.player.motionInformation.maxCrouchingSpeed;
				ownCmdValue.defaultFallingSpeed		 = g_currentMission.player.motionInformation.maxFallingSpeed;
				ownCmdValue.defaultCheatRunningSpeed = g_currentMission.player.motionInformation.maxCheatRunningSpeed;
			end;
			if args[1] == "mouseButtonMiddle" then				
				ownCmdValue.isLevel = 0;
				ownCmdValue.maxLevel = 60;
				ownCmdValue.minLevel = -5;
				g_currentMission.player.motionInformation.maxCrouchingSpeed		= ownCmdValue.defaultCrouchingSpeed; --2
				g_currentMission.player.motionInformation.maxSwimmingSpeed 		= ownCmdValue.defaultSwimmingSpeed;	--3	
				g_currentMission.player.motionInformation.maxWalkingSpeed		= ownCmdValue.defaultWalkingSpeed; --4
				g_currentMission.player.motionInformation.maxFallingSpeed		= ownCmdValue.defaultFallingSpeed; --6
				g_currentMission.player.motionInformation.maxRunningSpeed 		= ownCmdValue.defaultRunningSpeed; --9
				g_currentMission.player.motionInformation.maxCheatRunningSpeed	= ownCmdValue.defaultCheatRunningSpeed; --34
				if colorRotationIcon then
					moSetGetOverlays:setBackgroundColor(moSetGetOverlays.appIcon[args[4].whereClick][iconName], moColors.intern["darkGray"]);
					setOverlayRotation(moSetGetOverlays.appIcon[args[4].whereClick]["runJumpFlySpeedAppIcon2_"].overlayId, 0, 0+(moSetGetOverlays.appIcon[args[4].whereClick][iconName].width/2), 0+(moSetGetOverlays.appIcon[args[4].whereClick][iconName].height/2));
				end;			
			elseif args[1] == "mouseButtonLeft" then
				if ownCmdValue.isLevel+5 > ownCmdValue.maxLevel then 
					if colorRotationIcon then moSetGetOverlays:setBackgroundColor(moSetGetOverlays.appIcon[args[4].whereClick][iconName], moColors.intern["darkBlue"]);end;
					return;
				end;
				ownCmdValue.isLevel = ownCmdValue.isLevel+5;
				g_currentMission.player.motionInformation.maxCrouchingSpeed = (ownCmdValue.isLevel/2.5)+ownCmdValue.defaultCrouchingSpeed;
				g_currentMission.player.motionInformation.maxSwimmingSpeed = (ownCmdValue.isLevel/2)+ownCmdValue.defaultSwimmingSpeed;
				g_currentMission.player.motionInformation.maxWalkingSpeed = (ownCmdValue.isLevel/1.5)+ownCmdValue.defaultWalkingSpeed;
				g_currentMission.player.motionInformation.maxFallingSpeed = (ownCmdValue.isLevel)+ownCmdValue.defaultFallingSpeed;
				g_currentMission.player.motionInformation.maxRunningSpeed = (ownCmdValue.isLevel*1.7)+ownCmdValue.defaultRunningSpeed;				
				g_currentMission.player.motionInformation.maxCheatRunningSpeed = (ownCmdValue.isLevel*2.5)+ownCmdValue.defaultCheatRunningSpeed;
				
				if colorRotationIcon then					
					local newRotation = (ownCmdValue.rotation.level/6)*ownCmdValue.isLevel;
					if ownCmdValue.isLevel > 0 then 
						setOverlayRotation(moSetGetOverlays.appIcon[args[4].whereClick]["runJumpFlySpeedAppIcon2_"].overlayId, newRotation, 0+(moSetGetOverlays.appIcon[args[4].whereClick][iconName].width/2), 0+(moSetGetOverlays.appIcon[args[4].whereClick][iconName].height/2));
						moSetGetOverlays:setBackgroundColor(moSetGetOverlays.appIcon[args[4].whereClick][iconName], moColors.intern["darkGreen"]);
					elseif ownCmdValue.isLevel < 0 then						
						newRotation = (ownCmdValue.isLevel)*(ownCmdValue.rotation.level);
						setOverlayRotation(moSetGetOverlays.appIcon[args[4].whereClick]["runJumpFlySpeedAppIcon2_"].overlayId, newRotation, 0+(moSetGetOverlays.appIcon[args[4].whereClick][iconName].width/2), 0+(moSetGetOverlays.appIcon[args[4].whereClick][iconName].height/2));
						moSetGetOverlays:setBackgroundColor(moSetGetOverlays.appIcon[args[4].whereClick][iconName], moColors.intern["warningRed"]);
					elseif ownCmdValue.isLevel == 0 then
						MultiOverlayV3.runJumpFlySpeedApp.playerSpeedHighNormalSlow("mouseButtonMiddle", args[2], args[3], args[4]);						
					end;										
				end;
			elseif args[1] == "mouseButtonRight" then
				if ownCmdValue.isLevel-5 < ownCmdValue.minLevel then
					if colorRotationIcon then moSetGetOverlays:setBackgroundColor(moSetGetOverlays.appIcon[args[4].whereClick][iconName], moColors.intern["darkBlue"]);end;
					return;
				end;
				ownCmdValue.isLevel = ownCmdValue.isLevel-5;
				g_currentMission.player.motionInformation.maxCrouchingSpeed = (ownCmdValue.isLevel/2.5)+ownCmdValue.defaultCrouchingSpeed;
				g_currentMission.player.motionInformation.maxSwimmingSpeed = (ownCmdValue.isLevel/2)+ownCmdValue.defaultSwimmingSpeed;
				g_currentMission.player.motionInformation.maxWalkingSpeed = (ownCmdValue.isLevel/1.5)+ownCmdValue.defaultWalkingSpeed;
				g_currentMission.player.motionInformation.maxFallingSpeed = (ownCmdValue.isLevel)+ownCmdValue.defaultFallingSpeed;
				g_currentMission.player.motionInformation.maxRunningSpeed = (ownCmdValue.isLevel*1.7)+ownCmdValue.defaultRunningSpeed;				
				g_currentMission.player.motionInformation.maxCheatRunningSpeed = (ownCmdValue.isLevel*2.5)+ownCmdValue.defaultCheatRunningSpeed;
				if colorRotationIcon then					
					local newRotation = (ownCmdValue.rotation.level/6)*ownCmdValue.isLevel;
					if ownCmdValue.isLevel > 0 then 
						setOverlayRotation(moSetGetOverlays.appIcon[args[4].whereClick]["runJumpFlySpeedAppIcon2_"].overlayId, newRotation, 0+(moSetGetOverlays.appIcon[args[4].whereClick][iconName].width/2), 0+(moSetGetOverlays.appIcon[args[4].whereClick][iconName].height/2));
						moSetGetOverlays:setBackgroundColor(moSetGetOverlays.appIcon[args[4].whereClick][iconName], moColors.intern["darkGreen"]);
					elseif ownCmdValue.isLevel < 0 then						
						newRotation = (ownCmdValue.isLevel)*(ownCmdValue.rotation.level);
						setOverlayRotation(moSetGetOverlays.appIcon[args[4].whereClick]["runJumpFlySpeedAppIcon2_"].overlayId, newRotation, 0+(moSetGetOverlays.appIcon[args[4].whereClick][iconName].width/2), 0+(moSetGetOverlays.appIcon[args[4].whereClick][iconName].height/2));
						moSetGetOverlays:setBackgroundColor(moSetGetOverlays.appIcon[args[4].whereClick][iconName], moColors.intern["warningRed"]);
					elseif ownCmdValue.isLevel == 0 then
						MultiOverlayV3.runJumpFlySpeedApp.playerSpeedHighNormalSlow("mouseButtonMiddle", args[2], args[3], args[4]);
					end;										
				end;
			end;
		end;
	end;
end;

function MultiOverlayV3.runJumpFlySpeedApp.playerFlightModus(...)
	if ... ~= nil then		
		local args = {...};		
		if args ~= nil and args[1] ~= nil and args[2] ~= nil and args[3] ~= nil and args[4] ~= nil then
			--if not g_currentMission.isMasterUser then 
			--	g_currentMission.hud:showInGameMessage("RunJumpFlySpeed App Info", "Flight Modus is Only for Admin Users", 0);
			--	return;
			--end;			
			local searchCmdSpeedPos = 0;			
			if args[6] ~= nil then --simulatan ausführen playerFlightSpeedModus
				for cmd=1, #MultiOverlayV3.cmdTable[MultiOverlayV3.ownCmdTable].cmd do
					local isCmd = MultiOverlayV3.cmdTable[MultiOverlayV3.ownCmdTable].cmd[cmd];
					if isCmd ~= nil then						
						if MultiOverlayV3.cmdTable[MultiOverlayV3.runJumpFlySpeedApp.ownCmdTable].cmd[cmd].name == "playerSpeedHighNormalSlow" then searchCmdSpeedPos = cmd;break;end;						
					end;
				end;
			end;			
			local iconName = Utils.getNoNil(args[4].appIconName, "")		
			local colorIcon = iconName ~= nil and string.len(iconName) > 0 and iconName == "runJumpFlySpeedAppIcon3_" and moSetGetOverlays.appIcon[args[4].whereClick][iconName] ~= nil; --check ist richtige icon für cmd und multi color
			if g_currentMission.player.debugFlightMode then				
				g_currentMission.player.debugFlightMode = false;				
				Player:consoleCommandToggleFlightAndNoHUDMode();
				--removeConsoleCommand("gsToggleFlightAndNoHUDMode");
				if colorIcon then moSetGetOverlays:setBackgroundColor(moSetGetOverlays.appIcon[args[4].whereClick][iconName], moColors.intern["darkGray"]);end;
				if searchCmdSpeedPos > 0 then MultiOverlayV3.runJumpFlySpeedApp.playerSpeedHighNormalSlow("mouseButtonRight", args[2], searchCmdSpeedPos, args[4], 1);end;
			else 
				--removeConsoleCommand("gsToggleFlightAndNoHUDMode");
				--addConsoleCommand("gsToggleFlightAndNoHUDMode", "Toggle debug mode for Jump", "consoleCommandToggleFlightAndNoHUDMode");
				g_currentMission.player.debugFlightMode = true;
				Player:consoleCommandToggleFlightAndNoHUDMode();
				if colorIcon then moSetGetOverlays:setBackgroundColor(moSetGetOverlays.appIcon[args[4].whereClick][iconName], moColors.intern["darkBlue"]);end;
				if searchCmdSpeedPos > 0 then MultiOverlayV3.runJumpFlySpeedApp.playerSpeedHighNormalSlow("mouseButtonLeft", args[2], searchCmdSpeedPos, args[4], 45);end;
			end;
		end;
	end;
end;

function MultiOverlayV3.runJumpFlySpeedApp.playerFlightSpeedModus(...)
	if ... ~= nil then		
		local args = {...};		
		if args ~= nil and args[1] ~= nil and args[2] ~= nil and args[3] ~= nil and args[4] ~= nil then
			MultiOverlayV3.runJumpFlySpeedApp.playerFlightModus(args[1], args[2], args[3], args[4], true);
		end;
	end;
end;

function MultiOverlayV3.runJumpFlySpeedApp.playerJumpHighNormalLow(...)
	if ... ~= nil then		
		local args = {...};		
		if args ~= nil and args[1] ~= nil and args[2] ~= nil and args[3] ~= nil and args[4] ~= nil then
			--if not g_currentMission.isMasterUser then 
			--	g_currentMission.hud:showInGameMessage("RunJumpFlySpeed App Info", "Jump Modus is Only for Admin Users", 0);
			--	return;
			--end;
			local ownCmdValue = MultiOverlayV3.cmdTable[args[2]].cmd[args[3]].ownValues;
			if ownCmdValue == nil or type(ownCmdValue) ~= "table" then return;end;
			if ownCmdValue.defaultJump == 0 then --saved first default values
				ownCmdValue.defaultJump = g_currentMission.player.motionInformation.jumpHeight;
			end;
			local iconName = Utils.getNoNil(args[4].appIconName, "")		
			local colorIcon = iconName ~= nil and string.len(iconName) > 0 and iconName == "runJumpFlySpeedAppIcon4_" and moSetGetOverlays.appIcon[args[4].whereClick][iconName] ~= nil; --check ist richtige icon für cmd und multi color
			if args[1] == "mouseButtonLeft" then
				ownCmdValue.isJump = ownCmdValue.isJump+1
				if ownCmdValue.isJump >= 10 then
					ownCmdValue.isJump = 10;
					if colorIcon then moSetGetOverlays:setBackgroundColor(moSetGetOverlays.appIcon[args[4].whereClick][iconName], moColors.intern["darkBlue"]);end;
				else
					g_currentMission.player.motionInformation.jumpHeight = ownCmdValue.defaultJump*ownCmdValue.isJump;
					if colorIcon then moSetGetOverlays:setBackgroundColor(moSetGetOverlays.appIcon[args[4].whereClick][iconName], moColors.intern["darkGreen"]);end;
				end;							
			elseif args[1] == "mouseButtonMiddle" then
				g_currentMission.player.motionInformation.jumpHeight = ownCmdValue.defaultJump;ownCmdValue.isJump = 1;
				if colorIcon then moSetGetOverlays:setBackgroundColor(moSetGetOverlays.appIcon[args[4].whereClick][iconName], moColors.intern["darkGray"]);end;
			elseif args[1] == "mouseButtonRight" then
				ownCmdValue.isJump = ownCmdValue.isJump-1;
				if ownCmdValue.isJump < 1 then 
					ownCmdValue.isJump = 1;
					g_currentMission.player.motionInformation.jumpHeight = ownCmdValue.defaultJump;
					if colorIcon then moSetGetOverlays:setBackgroundColor(moSetGetOverlays.appIcon[args[4].whereClick][iconName], moColors.intern["darkGray"]);end;
				else
					g_currentMission.player.motionInformation.jumpHeight = ownCmdValue.defaultJump*ownCmdValue.isJump;
					if colorIcon then moSetGetOverlays:setBackgroundColor(moSetGetOverlays.appIcon[args[4].whereClick][iconName], moColors.intern["darkGreen"]);end;
				end;				
			end;
		end;
	end;
end;