animals = {};

--needs module animals, items
--lineType 2/animals by name
function animals:load(animalName)	
	local lineTable = {lineTyp=2, txtScroll={leftRight=true,upDown=true}};
	if moAnimals.values.animals ~= nil and moAnimals.values.animals[animalName] ~= nil then
		for animal=1, #moAnimals.values.animals[animalName] do
			if moAnimals.values.animals[animalName][animal] ~= nil then
				local animalGeneral = moAnimals.values.animals[animalName][animal].general[1];
				lineTable[#lineTable+1] = {};
				local isLineTable = lineTable[#lineTable];				
				
				if #moAnimals.values.animals[animalName] > 1 and animal ~= 1 then					
					isLineTable.setLineBorderNewObject = true;	
				end;
				
				isLineTable.lineClickHelp = true;
				isLineTable.lineClickHelpCallback = animals.returnLineHelpIconClick
				isLineTable.helpTxt = "Click AnimalTyp/AnimalName/%/FillLevel or .... ++ for more info (or MapHotSpot)";			
				
				local color = 1;				
				isLineTable.ownValues = {animalName};
				isLineTable.txt = {};			
				isLineTable.txt[1] = {};			
				isLineTable.txt[1].nodeId = animalGeneral.object.nodeId;
				--isLineTable.txt[1].width = 80;	--width prozent	
				isLineTable.txt[1].color = moColors:getColor(moModule.values.txtTitleColor);
				isLineTable.txt[1].bold = true;			
				local isNearObject = moModule:nearPlayerPosition(animalGeneral.object, 26);				
				if isNearObject ~= nil then	isLineTable.txt[1].clickCallback = animals.returnClickObjectName;end;				
				if isNearObject ~= nil and isNearObject then
					isLineTable.txt[1].txt = ">>".. animalGeneral.objectName.. "<<";
				else
					isLineTable.txt[1].txt = animalGeneral.objectName;
				end;
				isLineTable.txt[1].txtPos = 1;
				
				
				--isLineTable.txt[2] = {};
				--isLineTable.txt[2].width = 20;	--width prozent	
				--isLineTable.txt[2].color = moColors:getColor(moModule.values.txtTitleColor);
				--isLineTable.txt[2].bold = true;
				--isLineTable.txt[2].txt = tostring(#moAnimals.values.animals[animalName]);			
			
				lineTable[#lineTable+1] = {};
				isLineTable = lineTable[#lineTable];			
				isLineTable.ownValues = {animalName};
				isLineTable.txt = {};
				isLineTable.txt[1] = {};			
				isLineTable.txt[1].width = 80;	--width prozent	
				isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor)
				isLineTable.txt[1].bold = moModule.values.txtBold;
				isLineTable.txt[1].txt = animalGeneral.animalName;
				isLineTable.txt[2] = {};			
				isLineTable.txt[2].width = 20;	--width prozent	
				isLineTable.txt[2].color = moColors:getColor(moModule.values.txtColor)
				isLineTable.txt[2].bold = moModule.values.txtBold;
				isLineTable.txt[2].txt = animalGeneral.numAnimals;
				isLineTable.txt[2].txtPos = 2;
				--reproduktionsRate
				if animalGeneral.reproductionTimePerDay ~= nil then
					isLineTable.txt[1].clickCallback = animals.returnClickReproduktionsRate;
					isLineTable.txt[1].ownValues = {tostring(animalGeneral.reproductionTimePerDay), tostring(animalGeneral.reproductionTimePerDayName), true};
				end;
				--reproduktionsRate
				--productivity
				if animalName ~= "HORSE" and animalName ~= "DOG" then
					lineTable[#lineTable+1] = {};
					isLineTable = lineTable[#lineTable];				
					isLineTable.ownValues = {animalName};
					isLineTable.txt = {};			
					isLineTable.txt[1] = {};			
					isLineTable.txt[1].width = 80;	--width prozent	
					color = Utils.getNoNil(moColors.prozent[animalGeneral.productivityColor], 1);
					isLineTable.txt[1].color = moColors:getColor(color, nil, moModule.values.txtColor);
					isLineTable.txt[1].bold = moModule.values.txtBold;
					isLineTable.txt[1].txt = animalGeneral.productivityName;
					isLineTable.txt[2] = {};			
					isLineTable.txt[2].width = 20;	--width prozent	
					isLineTable.txt[2].color = moColors:getColor(color, nil, moModule.values.txtColor);
					isLineTable.txt[2].bold = moModule.values.txtBold;
					isLineTable.txt[2].txt = animalGeneral.productivity.. "%";
					isLineTable.txt[2].txtPos = 2;
				end;
				--productivity
				--cleanliness
				if animalGeneral.cleanLiness ~= nil then
					lineTable[#lineTable+1] = {};
					isLineTable = lineTable[#lineTable];				
					isLineTable.ownValues = {animalName};
					isLineTable.txt = {};				
					isLineTable.txt[1] = {};
					isLineTable.txt[1].width = 80;	--width prozent	
					color = Utils.getNoNil(moColors.prozent[animalGeneral.cleanLinessColor], 1);
					isLineTable.txt[1].color = moColors:getColor(color, nil, moModule.values.txtColor);
					isLineTable.txt[1].bold = moModule.values.txtBold;
					isLineTable.txt[1].txt = animalGeneral.cleanLinessName;
					isLineTable.txt[2] = {};			
					isLineTable.txt[2].width = 20;	--width prozent	
					isLineTable.txt[2].color = moColors:getColor(color, nil, moModule.values.txtColor);
					isLineTable.txt[2].bold = moModule.values.txtBold;
					isLineTable.txt[2].txt = animalGeneral.cleanLiness.. "%";
					isLineTable.txt[2].txtPos = 2;
				end;			
				--cleanliness				
				--output
				local animalOutput = moAnimals.values.animals[animalName][animal].output;
				if animalOutput ~= nil and #animalOutput > 0 then
					--isLineTable.lineBorder = {4, 0.0005, false, true, false, false, moColors:getColor(moAnimals.values.txtTitleColor)};				
					for output=1, #moAnimals.values.animals[animalName][animal].output do
						local outputTable = moAnimals.values.animals[animalName][animal].output[output];
						lineTable[#lineTable+1] = {};
						isLineTable = lineTable[#lineTable];				
						isLineTable.ownValues = {animalName};
						isLineTable.txt = {};			
						isLineTable.txt[1] = {};			
						isLineTable.txt[1].width = 80;	--width prozent
						isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor)
						isLineTable.txt[1].bold = moModule.values.txtBold;
						isLineTable.txt[1].txt = outputTable.fillTypeName;
						isLineTable.txt[2] = {};			
						isLineTable.txt[2].width = 20;	--width prozent
						isLineTable.txt[2].color = moColors:getColor(moModule.values.txtColor)
						isLineTable.txt[2].bold = moModule.values.txtBold;
						isLineTable.txt[2].txtPos = 2;
						if outputTable.palFull ~= nil and outputTable.palNotFull ~= nil then
							if outputTable.fillTypeRegName ~= nil and outputTable.fillTypeRegName == "EGG" then
								local palString = tostring(outputTable.palFull);
								if outputTable.palNotFull > 0 then palString = palString.. " (".. tostring(outputTable.palNotFull).. ")";end;
								isLineTable.txt[2].txt = tostring(palString); --..  tostring(outputTable.capacity);
							else
								local palString = tostring(outputTable.palFull).. " (".. tostring(outputTable.fillLevel).. ")";
								isLineTable.txt[2].txt = tostring(palString);
							end;
						else
							isLineTable.txt[2].txt = outputTable.fillLevel;
							isLineTable.txt[2].clickCallback = animals.returnClickFillLevelCapacityTotal;
							isLineTable.txt[2].ownValues = {tostring(outputTable.capacity), tostring(outputTable.percentageCapacity), true};
						end;
					end;
				end;			
				--output
				--input
				local animalInput = moAnimals.values.animals[animalName][animal].input;
				if animalInput ~= nil and #animalInput > 0 then					
					isLineTable.txt[1].lineBorder = {6, 0.0005, false, true, false, false, moColors.intern["darkGray"], 0};
					isLineTable.txt[2].lineBorder = {6, 0.0005, false, true, false, false, moColors.intern["darkGray"], 2};
					for input=1, #moAnimals.values.animals[animalName][animal].input do
						local inputTable = moAnimals.values.animals[animalName][animal].input[input];
						lineTable[#lineTable+1] = {};
						isLineTable = lineTable[#lineTable];					
						isLineTable.ownValues = {animalName};
						isLineTable.txt = {};						
						isLineTable.txt[1] = {};			
						isLineTable.txt[1].width = 80;	--width prozent
						isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor)
						isLineTable.txt[1].bold = moModule.values.txtBold;
						if inputTable.fillTypesTotal ~= nil and #inputTable.fillTypesTotal > 1 then
							isLineTable.txt[1].txt = inputTable.fillTypeName.. " ++";
							isLineTable.txt[1].fillTypesTotal = inputTable.fillTypesTotal;
							isLineTable.txt[1].clickCallback = animals.returnClickFillTypesTotal;							
						else
							isLineTable.txt[1].txt = inputTable.fillTypeName;
						end;
						isLineTable.txt[2] = {};			
						isLineTable.txt[2].width = 20;	--width prozent
						isLineTable.txt[2].color = moColors:getColor(moModule.values.txtColor)
						isLineTable.txt[2].bold = moModule.values.txtBold;
						isLineTable.txt[2].txt = tostring(inputTable.percentageCapacity).. "%";
						--isLineTable.txt[2].txt = tostring(inputTable.capacity) --tostring(inputTable.percentageCapacity).. "%";
						isLineTable.txt[2].clickCallback = animals.returnClickFillLevelCapacityTotal;
						isLineTable.txt[2].ownValues = {tostring(inputTable.capacity), tostring(inputTable.fillLevel)};						
						isLineTable.txt[2].txtPos = 2;
						--isLineTable.txt[2].txt = inputTable.fillLevel;
					end;
				end;
				--input
			end;
		end;
	end;
	animals[animalName] = {output=lineTable};	
end;

function animals.returnLineHelpIconClick(...)	
	if ... ~= nil then		
		local args = ...;		
		if args.line ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then
			moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
			moSetGetOverlays.infoHelpBox.help.txt = tostring(animals[args.ownValues[1]].output[args.line].helpTxt);
		end;
	end;
end;

function animals.returnClickReproduktionsRate(...)
	if ... ~= nil then
		local args = ...;		
		if args.line ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then			
			local reproductionTimePerDay = animals[args.ownValues[1]].output[args.line].txt[1].ownValues[1];
			local reproductionTimePerDayName = animals[args.ownValues[1]].output[args.line].txt[1].ownValues[2];						
			moSetGetOverlays.infoHelpBox.info.lsTimer = -1;						
			moSetGetOverlays.infoHelpBox.info.txt = tostring(reproductionTimePerDayName).. " ".. tostring(reproductionTimePerDay);				
		
		end;
	end;
end;

function animals.returnClickFillLevelCapacityTotal(...)
	if ... ~= nil then
		local args = ...;		
		if args.line ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then			
			local capacity = animals[args.ownValues[1]].output[args.line].txt[2].ownValues[1];
			local fillLevel = animals[args.ownValues[1]].output[args.line].txt[2].ownValues[2];
			local flipFillLevel = animals[args.ownValues[1]].output[args.line].txt[2].ownValues[3];
			--if string.len(capacity) > 0 then				
				moSetGetOverlays.infoHelpBox.info.lsTimer = -1;
				local capacityLanguage = moLanguageXml:getTxt("capacity", nil, "Capacity:");
				local fillcontainerLanguage = moLanguageXml:getTxt("fillcontainer", nil, "Foodtrough:");
				local prozent = ""
				if flipFillLevel ~= nil then prozent = "%";end;				
				moSetGetOverlays.infoHelpBox.info.txt = tostring(capacityLanguage).. " ".. tostring(capacity).. "\n".. tostring(fillcontainerLanguage).. " ".. tostring(fillLevel).. tostring(prozent);				
			--end;
		end;
	end;
end;

function animals.returnClickFillTypesTotal(...)
	if ... ~= nil then
		local args = ...;
		if args.line ~= nil and args.position ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then
			local fillTypesTotal = animals[args.ownValues[1]].output[args.line].txt[1].fillTypesTotal;
			local fillTypeNamen = "";			
			for _, fillType in pairs (fillTypesTotal) do				
				local fillTypes = moFillTypes.values.fillTypes[fillType];
				if fillTypes ~= nil then
					fillTypeNamen = fillTypeNamen.. tostring(fillTypes.name).. " - ";
				end;										
			end;
			if string.len(fillTypeNamen) > 0 then
				moSetGetOverlays.infoHelpBox.info.lsTimer = -1;
				moSetGetOverlays.infoHelpBox.info.txt = tostring(fillTypeNamen);	
			end;
		end;
	end;
end;

function animals.returnClickObjectName(...)
	if ... ~= nil then
		local args = ...;
		if args ~= nil and args.line ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then
			local animalName = args.ownValues[1];			
			if animals[animalName] ~= nil and animals[animalName].output ~= nil and animals[animalName].output[args.line] ~= nil then
				local nodeId = animals[animalName].output[args.line].txt[1].nodeId;
				local x, _, z = getWorldTranslation(nodeId);
				moSetGetOverlays:mapHotSpot(nil, x, z);	
			end;			
		end;		
	end;
end;

function animals.giveOutputTable(...)	
	if ... ~= nil then
		local args = ...;
		moModule.active.animals.isRunning = true;moModule.active.animals.last = moModule.time.min+moModule.time.delay;
		moModule.active.items.isRunning = true;moModule.active.items.last = moModule.time.min+moModule.time.delay;
		if args.ownValues ~= nil and args.ownValues[1] ~= nil then
			local animalName = args.ownValues[1];			
			animals:load(animalName);
			return animals[animalName].output;
		end;
	end;	
end;


function animals.reset(whichSLOT)
	if whichSLOT ~= nil and moSetGetOverlays.slot[whichSLOT] ~= nil then moSetGetOverlays.slot[whichSLOT].save = false;end;
	--animals:load();	
end;

function animals:generateCmd(animalName)
	local _, errorTable = 0, {};
	function insertCmd(animalName, objectsNodes, objectsIds)
		local newCmdTable = { insert=true, cmdOldTable=MultiOverlayV3.moduleCmdTable, cmdTable = {} };	
		local animalNameTemp = tostring(animalName):lower();
		local languageName = moLanguageXml:getTxt(animalNameTemp, nil, animalName);
		newCmdTable.cmdTable[1] = {
			cmdName = "animals_".. animalName;			
			displayName = moLanguageXml:getTxt("animalsstall", nil, "Animalsstall").. " ".. tostring(languageName);	
			multiple = true;
			sortBy = "Animals";
			infoTxt = "Zeigt alle Tierställe an (".. tostring(languageName).. ")";
			helpTxt = "View all Animalsstall (".. tostring(animalName).. ")";
			click = {mouseButtonLeft=true, mouseButtonMiddle=true, mouseButtonRight=true, key=true};
			lineTyp = 2;
			typ = "output";
			action = animals.giveOutputTable; --a function
			ownValues = {animalName, objectsNodes, objectsIds}; 
		};	
		_, errorTable = moSetGetCmd:generateNewCmd(newCmdTable);
		local errorPrint = false;
		if errorPrint and #errorTable > 0 then
			for a=1, #errorTable do
				print("! ERROR ! MultiOverlayV3 Hud -->cmd generate animals ".. tostring(animalName).. " Cmd error ".. tostring(a).. ": ".. tostring(errorTable[a]))
			end;
		end;
	end;
	if animalName ~= nil then 
		local isAlreadyExits = moSetGetCmd:cmdFromReady(nil, "animals_".. animalName, "multioverlayV3Module", tostring(MultiOverlayV3.metadata.title), true, MultiOverlayV3.moduleCmdTable);
		if isAlreadyExits == nil then insertCmd(animalName);end;
	else
		if moAnimals.values.animals ~= nil then
			for animalName, _ in pairs (moAnimals.values.animals) do
				local isAlreadyExits = moSetGetCmd:cmdFromReady(nil, "animals_".. animalName, "multioverlayV3Module", tostring(MultiOverlayV3.metadata.title), true, MultiOverlayV3.moduleCmdTable);
				if isAlreadyExits == nil then insertCmd(animalName, moModule:getObjectIds(moAnimals.values.animals[animalName], false));end;
			end;
		end;
	end;	
end;


